#
# Copyright (c) 2015 LAAS/CNRS
# All rights reserved.
#
# Permission to use, copy, modify, and distribute this software for any purpose
# with or without   fee is hereby granted, provided   that the above  copyright
# notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
# REGARD TO THIS  SOFTWARE INCLUDING ALL  IMPLIED WARRANTIES OF MERCHANTABILITY
# AND FITNESS. IN NO EVENT SHALL THE AUTHOR  BE LIABLE FOR ANY SPECIAL, DIRECT,
# INDIRECT, OR CONSEQUENTIAL DAMAGES OR  ANY DAMAGES WHATSOEVER RESULTING  FROM
# LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
# OTHER TORTIOUS ACTION,   ARISING OUT OF OR IN    CONNECTION WITH THE USE   OR
# PERFORMANCE OF THIS SOFTWARE.
#
#                                             Anthony Mallet on Mon May 18 2015
#
from __future__ import print_function

import datetime
import os
import sys

_argv0 = os.path.basename(sys.argv[0])
_verbose = 0

# --- verbose --------------------------------------------------------------
#
def argv0():
  global _argv0
  return _argv0


# --- verbose --------------------------------------------------------------
#
def verbose():
  global _verbose
  _verbose += 1


# --- infox ----------------------------------------------------------------
#
def infox(msg, level=0):
  global _verbose
  if _verbose > level:
    warnx(msg, sys.stdout)


# --- warnx ----------------------------------------------------------------
#
def warnx(msg, channel=sys.stderr):
  global _argv0

  ts = datetime.datetime.now().strftime('%T.%f')
  print("%s:%s: %s" % (ts, _argv0, msg), file=channel)



# --- generic catchable exception ------------------------------------------
#
class softerror(Exception):
  pass
